import type { PropValidators, CheckboxFacadeTheme } from '@instructure/shared-types';
import type { WithStyleProps, ComponentStyle } from '@instructure/emotion';
type CheckboxFacadeOwnProps = {
    children: React.ReactNode;
    checked?: boolean;
    focused?: boolean;
    hovered?: boolean;
    size?: 'small' | 'medium' | 'large';
    /**
     * Visual state showing that child checkboxes are a combination of checked and unchecked
     */
    indeterminate?: boolean;
    /**
     * Indicate if the parent component (`Checkbox`) is invalid to set the style accordingly.
     */
    invalid?: boolean;
};
type PropKeys = keyof CheckboxFacadeOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type CheckboxFacadeProps = CheckboxFacadeOwnProps & WithStyleProps<CheckboxFacadeTheme, CheckboxFacadeStyle>;
type CheckboxFacadeStyle = ComponentStyle<'checkboxFacade' | 'facade' | 'label'>;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
export type { CheckboxFacadeProps, CheckboxFacadeStyle };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map