import React from 'react';
import type { PropValidators, ToggleFacadeTheme } from '@instructure/shared-types';
import type { WithStyleProps, ComponentStyle } from '@instructure/emotion';
type ToggleFacadeOwnProps = {
    children: React.ReactNode;
    checked?: boolean;
    disabled?: boolean;
    readOnly?: boolean;
    focused?: boolean;
    size?: 'small' | 'medium' | 'large';
    labelPlacement?: 'top' | 'start' | 'end';
    /**
     * Indicate if the parent component (`Checkbox`) is invalid to set the style accordingly.
     */
    invalid?: boolean;
};
type PropKeys = keyof ToggleFacadeOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type ToggleFacadeProps = ToggleFacadeOwnProps & WithStyleProps<ToggleFacadeTheme, ToggleFacadeStyle>;
type ToggleFacadeStyle = ComponentStyle<'toggleFacade' | 'facade' | 'icon' | 'iconToggle' | 'iconSVG' | 'label'>;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
export type { ToggleFacadeProps, ToggleFacadeStyle };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map