import { Component } from 'react';
import { CheckboxFacade } from './CheckboxFacade';
import { ToggleFacade } from './ToggleFacade';
import type { CheckboxProps, CheckboxState } from './props';
/**
---
category: components
tags: toggle, switch
---
**/
declare class Checkbox extends Component<CheckboxProps, CheckboxState> {
    static readonly componentId = "Checkbox";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        label: React.ReactNode;
        id?: string;
        value?: string | number;
        messages?: import("@instructure/ui-form-field").FormMessage[];
        defaultChecked?: boolean;
        checked?: boolean;
        onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
        onKeyDown?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
        onFocus?: (e: React.FocusEvent<HTMLInputElement>) => void;
        onBlur?: (e: React.FocusEvent<HTMLInputElement>) => void;
        onMouseOver?: (e: React.MouseEvent<HTMLInputElement>) => void;
        onMouseOut?: (e: React.MouseEvent<HTMLInputElement>) => void;
        disabled?: boolean;
        readOnly?: boolean;
        indeterminate?: boolean;
        size?: "small" | "medium" | "large";
        variant?: "simple" | "toggle";
        inline?: boolean;
        labelPlacement?: "top" | "start" | "end";
        isRequired?: boolean;
    }>;
    static allowedProps: readonly (keyof {
        label: React.ReactNode;
        id?: string;
        value?: string | number;
        messages?: import("@instructure/ui-form-field").FormMessage[];
        defaultChecked?: boolean;
        checked?: boolean;
        onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
        onKeyDown?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
        onFocus?: (e: React.FocusEvent<HTMLInputElement>) => void;
        onBlur?: (e: React.FocusEvent<HTMLInputElement>) => void;
        onMouseOver?: (e: React.MouseEvent<HTMLInputElement>) => void;
        onMouseOut?: (e: React.MouseEvent<HTMLInputElement>) => void;
        disabled?: boolean;
        readOnly?: boolean;
        indeterminate?: boolean;
        size?: "small" | "medium" | "large";
        variant?: "simple" | "toggle";
        inline?: boolean;
        labelPlacement?: "top" | "start" | "end";
        isRequired?: boolean;
    })[];
    static defaultProps: {
        size: string;
        variant: string;
        disabled: boolean;
        inline: boolean;
        indeterminate: boolean;
        readOnly: boolean;
        labelPlacement: string;
    };
    constructor(props: CheckboxProps);
    private readonly _defaultId;
    private _input;
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    componentDidMount(): void;
    componentDidUpdate(prevProps: CheckboxProps): void;
    handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleKeyDown: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    handleFocus: () => void;
    handleBlur: () => void;
    handleMouseOver: () => void;
    handleMouseOut: () => void;
    get id(): string;
    get checked(): boolean | undefined;
    get focused(): boolean;
    get isNewError(): boolean;
    get invalid(): boolean;
    focus(): void;
    renderFacade(): import("@emotion/react/jsx-runtime").JSX.Element;
    renderMessages(): import("@emotion/react/jsx-runtime").JSX.Element | null;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default Checkbox;
export { Checkbox, CheckboxFacade, ToggleFacade };
//# sourceMappingURL=index.d.ts.map