import { Component } from 'react';
import type { CheckboxGroupProps, CheckboxGroupState, CheckboxChild } from './props';
/**
---
category: components
---
**/
declare class CheckboxGroup extends Component<CheckboxGroupProps, CheckboxGroupState> {
    static readonly componentId = "CheckboxGroup";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        children?: CheckboxChild[];
        name: string;
        description: React.ReactNode;
        defaultValue?: (string | number)[];
        value?: (string | number)[];
        onChange?: (value: (string | number)[]) => void;
        disabled?: boolean;
        readOnly?: boolean;
        messages?: import("@instructure/ui-form-field").FormMessage[];
        size?: "small" | "medium" | "large";
        layout?: "stacked" | "columns" | "inline";
    }>;
    static allowedProps: readonly (keyof {
        children?: CheckboxChild[];
        name: string;
        description: React.ReactNode;
        defaultValue?: (string | number)[];
        value?: (string | number)[];
        onChange?: (value: (string | number)[]) => void;
        disabled?: boolean;
        readOnly?: boolean;
        messages?: import("@instructure/ui-form-field").FormMessage[];
        size?: "small" | "medium" | "large";
        layout?: "stacked" | "columns" | "inline";
    })[];
    static defaultProps: {
        disabled: boolean;
        readOnly: boolean;
        size: string;
        layout: string;
        children: null;
    };
    constructor(props: CheckboxGroupProps);
    private readonly _messagesId;
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    get hasMessages(): boolean | undefined;
    handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    get value(): (string | number)[];
    renderChildren(): CheckboxChild[] | undefined;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default CheckboxGroup;
export { CheckboxGroup };
//# sourceMappingURL=index.d.ts.map