import { type InputHTMLAttributes } from 'react';
import type { FormMessage } from '@instructure/ui-form-field';
import type { OtherHTMLAttributes, PropValidators } from '@instructure/shared-types';
import type { WithDeterministicIdProps } from '@instructure/ui-react-utils';
import { Checkbox } from '../Checkbox';
import type { CheckboxProps } from '../Checkbox/props';
type CheckboxChild = React.ComponentElement<CheckboxProps, Checkbox>;
type CheckboxGroupOwnProps = {
    children?: CheckboxChild[];
    name: string;
    description: React.ReactNode;
    defaultValue?: (string | number)[];
    value?: (string | number)[];
    onChange?: (value: (string | number)[]) => void;
    disabled?: boolean;
    readOnly?: boolean;
    messages?: FormMessage[];
    size?: 'small' | 'medium' | 'large';
    layout?: 'stacked' | 'columns' | 'inline';
};
type PropKeys = keyof CheckboxGroupOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type CheckboxGroupProps = CheckboxGroupOwnProps & OtherHTMLAttributes<CheckboxGroupOwnProps, InputHTMLAttributes<CheckboxGroupOwnProps & Element>> & WithDeterministicIdProps;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
type CheckboxGroupState = {
    value: (string | number)[];
};
export type { CheckboxGroupProps, CheckboxGroupState, CheckboxChild };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map